/**
 *    author:  tourist
 *    created: 06.10.2022 19:12:43       
**/
#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
#include "algo/debug.h"
#else
#define debug(...) 42
#endif

const double eps = 1e-9;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  string s;
  cin >> s;
  int n = (int) s.size();
  vector<vector<set<double>>> dp(n, vector<set<double>>(n));
  for (int i = n - 1; i >= 0; i--) {
    for (int j = i; j < n; j++) {
      int num = atoi(s.substr(i, j - i + 1).c_str());
      dp[i][j].insert(num);
      dp[i][j].insert(-num);
      for (int k = i; k < j; k++) {
        for (auto x : dp[i][k]) {
          for (auto y : dp[k + 1][j]) {
            dp[i][j].insert(x + y);
            dp[i][j].insert(x - y);
            dp[i][j].insert(x * y);
            if (abs(y) > eps) {
              dp[i][j].insert(x / y);
            }
          }
        }
      }
    }
  }
  function<string(int, int, double)> Build = [&](int i, int j, double goal) -> string {
    int num = atoi(s.substr(i, j - i + 1).c_str());
    if (abs(goal - num) < eps) {
      return s.substr(i, j - i + 1);
    }
    if (abs(goal - (-num)) < eps) {
      return "(-" + s.substr(i, j - i + 1) + ")";
    }
    for (int k = i; k < j; k++) {
      for (auto x : dp[i][k]) {
        for (auto y : dp[k + 1][j]) {
          if (abs(goal - (x + y)) < eps) {
            return "(" + Build(i, k, x) + "+" + Build(k + 1, j, y) + ")";
          }
          if (abs(goal - (x - y)) < eps) {
            return "(" + Build(i, k, x) + "-" + Build(k + 1, j, y) + ")";
          }
          if (abs(goal - (x * y)) < eps) {
            return "(" + Build(i, k, x) + "*" + Build(k + 1, j, y) + ")";
          }
          if (abs(y) > eps && abs(goal - (x / y)) < eps) {
            return "(" + Build(i, k, x) + "/" + Build(k + 1, j, y) + ")";
          }
        }
      }
    }
    assert(false);
    return "";
  };
  cout << Build(0, n - 1, 100) << '\n';
  return 0;
}
