#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

const long long MOD = 1e9 + 7;
const long long M = 59;
const long double EPS = 1e-8;

long long bp(long long a, long long p) {
	long long ret = 1;
	while (p)
		if (p & 1) {
			ret *= a;
			ret %= MOD;
			p--;
		}
		else {
			a *= a;
			a %= MOD;
			p >>= 1;
		}
	
	return ret;
}

int main() {
	int n, q;
	cin >> n >> q;
	
	vector <long long> bpows(100001);
	vector <long long> pows(100001);
	bpows[0] = 1;
	pows[0] = 1;
	bpows[1] = bp(M, MOD - 2);
	for (int i = 1; i < 100001; i++)
		bpows[i] = (bpows[i - 1] * bpows[1]) % MOD, pows[i] = (pows[i - 1] * M) % MOD;
	
	vector <string> s(n);
	vector <vector <long long>> hsh(n, vector <long long> (0));
	for (int i = 0; i < n; i++) {
		cin >> s[i];
		
		hsh[i].resize(s[i].length());
		hsh[i][0] = s[i][0] - 'a' + 1;
		for (int j = 1; j < s[i].size(); j++) {
			long long cur = s[i][j] - 'a' + 1;
			long long add = (cur * pows[j]) % MOD;
			hsh[i][j] = (hsh[i][j - 1] + add) % MOD;
		}
	}
	
	auto f = [&](int i, int a, int b) {
		long long ret = hsh[i][b];
		if (a > 0) {
			ret = (ret - hsh[i][a - 1] + MOD) % MOD;
			ret = (ret * bpows[a]) % MOD;
		}
		return ret;
	};
	
	while (q--) {
		int u, v, c;
		cin >> u >> v >> c;
		u--, v--;
		int z = s[u].length() - c, x = s[v].length() - c;
		
		long double mx, d = 1.0;
		if (s[u][z - 1] == s[v][x - 1])
			mx = 1.0;
		else
			mx = 0.5;
		
		int end = 1, cnt = 0;
		while (cnt < 20 && end <= min(z, x)) {
			if (s[u][z - end] != s[v][x - end]) {
				d *= 0.5;
				if (mx + EPS < (long double)(end) * d)
					mx = (long double)(end) * d;
				end++;
				cnt++;
				continue;
			}
			
			int l = end;
			int r = min(z, x);
			while (r - l > 1) {
				int m = (l + r) / 2;
				if (f(u, z - m, z - end) == f(v, x - m, x - end))
					l = m;
				else r = m;
			}
			
			while (min(z, x) - l - 1 >= 0 && s[u][z - l - 1] == s[v][x - l - 1]) l++;
			if (mx + EPS < (long double)(l) * d)
				mx = (long double)(l) * d;
			
			end = l + 1;
		}
		
		cout.precision(9);
		cout << fixed << mx << '\n';
	}
	
	return 0;
}