#include <iostream>
#include <vector>
#include <algorithm>
#include <functional>

using namespace std;

struct edge {
	int v;
	long long s, w;
	
	edge() {}
	edge(int _v, long long _s, long long _w) : v(_v), s(_s), w(_w) {}
};

int main() {
	int n, m, q;
	cin >> n >> m >> q;
	
	vector <vector <edge>> g(n);
	for (int i = 0; i < m; i++) {
		long long u, v, s, w;
		cin >> u >> v >> s >> w;
		u--, v--;
		g[u].push_back(edge(v, s, w));
	}
	
	for (int i = 0; i < q; i++) {
		long long a, b;
		cin >> a >> b;
		
		vector <char> used(n);
		function <void(int)> dfs = [&](int v) {
			used[v] = 1;
			for (auto to : g[v])
				if (a * to.s > b * to.w && !used[to.v])
					dfs(to.v);
		};
		
		dfs(0);
		if (used[n - 1]) cout << "YES\n";
		else cout << "NO\n";
	}
	
	return 0;
}